# adesk "Drawer" plugin

import gtk
import os
import adesk

class Plugin(adesk.Plugin):
    def __init__(self, bar, settings):
        adesk.Plugin.__init__(self, bar, settings)
        self.settings = settings
        self.can_zoom = True
        self.drawer = Drawer(self, bar)

    def onClick(self, widget, event):
        self.drawer.toggle()

    def resize(self):
        self.set_size_request(self.cfg['icon_size'], self.cfg['icon_size'])

class Drawer(adesk.ui.PopupWindow):
    def __init__(self, plugin, bar):
        adesk.ui.PopupWindow.__init__(self, bar, plugin)

        box = gtk.VBox(False, 0)
        box.set_border_width(0)
        self.add(box)

        for launcher in plugin.settings['launcher']:
            (cmd, icon, name) = launcher
            button = adesk.image_button(name, icon, 24)
            button.connect("button-release-event", self.onClicked, cmd)
            box.pack_start(button)
        self.set_size_request(200,-1)
        box.show_all()

    def onClicked(self, widget, event, cmd):
        adesk.launch_command(cmd)
        self.toggle(self)
