# -*- coding: utf-8 -*-

import gtk
import adesk

class Plugin(adesk.Plugin):
    def __init__(self, bar, settings):
        adesk.Plugin.__init__(self, bar, settings)
        self.settings = settings
        self.can_zoom = True
        self.hello = Hello(self, bar)

    def onClick(self, widget, event):
        self.hello.toggle()

    def resize(self):
        self.set_size_request(self.cfg['icon_size'], self.cfg['icon_size'])

class Hello(adesk.ui.PopupWindow):
    def __init__(self, plugin, bar):
        adesk.ui.PopupWindow.__init__(self, bar, plugin)

        btn = gtk.Button('Hello')
        btn.show()
        btn.set_relief(gtk.RELIEF_NONE)
        btn.set_border_width(0)
        btn.set_focus_on_click(False)
        btn.set_property('can-focus', False)

        self.add(btn)

    def toggle(self, widget = 0):
        adesk.ui.PopupWindow.toggle(self)
