# -*- coding: utf-8 -*-

import gtk
import adesk

class Plugin(adesk.Plugin):
    def __init__(self, bar, settings):
        adesk.Plugin.__init__(self, bar, settings)
        self.settings = settings
        self.can_zoom = True
        self.session = Session(self, bar)

    def onClick(self, widget, event):
        self.session.toggle()

    def resize(self):
        self.set_size_request(self.cfg['icon_size'], self.cfg['icon_size'])

class Session(adesk.ui.PopupWindow):
    def __init__(self, plugin, bar):
        adesk.ui.PopupWindow.__init__(self, bar, plugin)

        box = gtk.VBox(False, 0)
        box.set_border_width(0)
        self.add(box)

        session = { 'logout':('Log Out','log out the session.'),
                    'hibernate':('Hibernate','save session and power off.'),
                    'suspend':('Suspend','suspend session.'),
                    'reboot':('Reboot','restart computer.'),
                    'shutdown':('Shut Down','power off computer.'),
                    'lockscreen':('Lock Screen','lock screen to prevent unauthotised use.'),
                  }

        for action in ('lockscreen','logout','hibernate','suspend','reboot','shutdown'):
            if not plugin.settings[action] == '':
                image = 'images/plugins/session/%s.png' % action
                label = '%s\n%s' % (session[action][0], session[action][1])
                button = adesk.image_button(label, image, 24)
                button.connect("button-release-event", self.onClicked, plugin.settings[action])
                box.pack_start(button, False)

        box.show_all()

    def onClicked(self, widget, event, action):
        adesk.launch_command(action)

        ## hide window
        self.toggle(self)
